/*
 * JNvgraph - Java bindings for nvGRAPH, the NVIDIA CUDA graph library,
 * to be used with JCuda
 *
 * Copyright (c) 2016-2016 Marco Hutter - http://www.jcuda.org
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

 /* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
 /* Header for class jcuda_jnvgraph_JNvgraph */

#ifndef _Included_jcuda_jnvgraph_JNvgraph
#define _Included_jcuda_jnvgraph_JNvgraph
#ifdef __cplusplus
extern "C" {
#endif
	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    setLogLevelNative
	* Signature: (I)V
	*/
	JNIEXPORT void JNICALL Java_jcuda_jnvgraph_JNvgraph_setLogLevelNative
		(JNIEnv *, jclass, jint);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphStatusGetStringNative
	* Signature: (I)Ljava/lang/String;
	*/
	JNIEXPORT jstring JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphStatusGetStringNative
		(JNIEnv *, jclass, jint);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphGetPropertyNative
	* Signature: (I[I)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphGetPropertyNative
		(JNIEnv *, jclass, jint, jintArray);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphCreateNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphCreateNative
		(JNIEnv *, jclass, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphDestroyNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphDestroyNative
		(JNIEnv *, jclass, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphCreateGraphDescrNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphCreateGraphDescrNative
		(JNIEnv *, jclass, jobject, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphDestroyGraphDescrNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphDestroyGraphDescrNative
		(JNIEnv *, jclass, jobject, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphSetGraphStructureNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljava/lang/Object;I)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphSetGraphStructureNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jint);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphGetGraphStructureNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljava/lang/Object;[I)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphGetGraphStructureNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jintArray);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphAllocateVertexDataNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;JLjcuda/Pointer;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphAllocateVertexDataNative
		(JNIEnv *, jclass, jobject, jobject, jlong, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphAllocateEdgeDataNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;JLjcuda/Pointer;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphAllocateEdgeDataNative
		(JNIEnv *, jclass, jobject, jobject, jlong, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphSetVertexDataNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/Pointer;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphSetVertexDataNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphGetVertexDataNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/Pointer;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphGetVertexDataNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphConvertTopologyNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;ILjava/lang/Object;Ljcuda/Pointer;Ljcuda/Pointer;ILjava/lang/Object;Ljcuda/Pointer;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphConvertTopologyNative
		(JNIEnv *, jclass, jobject, jint, jobject, jobject, jobject, jint, jobject, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphConvertGraphNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/jnvgraph/nvgraphGraphDescr;I)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphConvertGraphNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jint);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphSetEdgeDataNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/Pointer;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphSetEdgeDataNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphGetEdgeDataNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/Pointer;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphGetEdgeDataNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphExtractSubgraphByVertexNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/Pointer;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphExtractSubgraphByVertexNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphExtractSubgraphByEdgeNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/Pointer;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphExtractSubgraphByEdgeNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphSrSpmvNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;JLjcuda/Pointer;JLjcuda/Pointer;JI)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphSrSpmvNative
		(JNIEnv *, jclass, jobject, jobject, jlong, jobject, jlong, jobject, jlong, jint);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalParameterInitNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalParameterInitNative
		(JNIEnv *, jclass, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalSetDistancesIndexNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalSetDistancesIndexNative
		(JNIEnv *, jclass, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalGetDistancesIndexNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;[J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalGetDistancesIndexNative
		(JNIEnv *, jclass, jobject, jlongArray);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalSetPredecessorsIndexNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalSetPredecessorsIndexNative
		(JNIEnv *, jclass, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalGetPredecessorsIndexNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;[J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalGetPredecessorsIndexNative
		(JNIEnv *, jclass, jobject, jlongArray);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalSetEdgeMaskIndexNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalSetEdgeMaskIndexNative
		(JNIEnv *, jclass, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalGetEdgeMaskIndexNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;[J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalGetEdgeMaskIndexNative
		(JNIEnv *, jclass, jobject, jlongArray);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalSetUndirectedFlagNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalSetUndirectedFlagNative
		(JNIEnv *, jclass, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalGetUndirectedFlagNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;[J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalGetUndirectedFlagNative
		(JNIEnv *, jclass, jobject, jlongArray);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalSetAlphaNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalSetAlphaNative
		(JNIEnv *, jclass, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalGetAlphaNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;[J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalGetAlphaNative
		(JNIEnv *, jclass, jobject, jlongArray);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalSetBetaNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalSetBetaNative
		(JNIEnv *, jclass, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalGetBetaNative
	* Signature: (Ljcuda/jnvgraph/nvgraphTraversalParameter;[J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalGetBetaNative
		(JNIEnv *, jclass, jobject, jlongArray);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTraversalNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;ILjcuda/Pointer;Ljcuda/jnvgraph/nvgraphTraversalParameter;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTraversalNative
		(JNIEnv *, jclass, jobject, jobject, jint, jobject, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphSsspNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;JLjcuda/Pointer;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphSsspNative
		(JNIEnv *, jclass, jobject, jobject, jlong, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphWidestPathNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;JLjcuda/Pointer;J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphWidestPathNative
		(JNIEnv *, jclass, jobject, jobject, jlong, jobject, jlong);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphPagerankNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;JLjcuda/Pointer;JIJFI)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphPagerankNative
		(JNIEnv *, jclass, jobject, jobject, jlong, jobject, jlong, jint, jlong, jfloat, jint);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphContractGraphNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/jnvgraph/nvgraphGraphDescr;Ljcuda/Pointer;JIIIII)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphContractGraphNative
		(JNIEnv *, jclass, jobject, jobject, jobject, jobject, jlong, jint, jint, jint, jint, jint);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphSpectralClusteringNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;JLjcuda/jnvgraph/SpectralClusteringParameter;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphSpectralClusteringNative
		(JNIEnv *, jclass, jobject, jobject, jlong, jobject, jobject, jobject, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphAnalyzeClusteringNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;JILjcuda/Pointer;ILjcuda/Pointer;)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphAnalyzeClusteringNative
		(JNIEnv *, jclass, jobject, jobject, jlong, jint, jobject, jint, jobject);

	/*
	* Class:     jcuda_jnvgraph_JNvgraph
	* Method:    nvgraphTriangleCountNative
	* Signature: (Ljcuda/jnvgraph/nvgraphHandle;Ljcuda/jnvgraph/nvgraphGraphDescr;[J)I
	*/
	JNIEXPORT jint JNICALL Java_jcuda_jnvgraph_JNvgraph_nvgraphTriangleCountNative
		(JNIEnv *, jclass, jobject, jobject, jlongArray);

#ifdef __cplusplus
}
#endif
#endif
